package cn.estsh.i3plus.pojo.platform.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description : 系统字典
 * @Reference   :
 * @Author      : wei.peng
 * @Date        : 2018-10-22 16:58:43.550
 * @Modify      :
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="SYS_DICTIONARY")
@Api(value="系统字典",description = "系统字典")
public class SysDictionary extends BaseBean {

    @Column(name="NAME")
    @ApiParam(value ="字典名称")
    private String name;
 
    @Column(name="DICTIONARY_CODE")
    @ApiParam(value ="字典代码")
    private String dictionaryCode;

    // 根节点-1
    @Column(name="PARENT_ID")
    @ApiParam(value ="父节点" , example = "-1")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long parentId;

    @Column(name="PARENT_NAME_RDD")
    @ApiParam(value ="父级节点名称")
    private String parentNameRdd;

    @Column(name="PARENT_CODEE_RDD")
    @ApiParam(value ="父级节点代码")
    private String parentCodeRdd;

    @Column(name="DICTIONARY_VALUE")
    @ApiParam(value ="字典值")
    private String dictionaryValue;
 
    @Column(name="DICTIONARY_SORT")
    @ApiParam(value ="排序" , example ="1")
    private Integer dictionarySort;
 
    @Column(name="DICTIONARY_DESCRIPTION")
    @ApiParam(value ="描述")
    private String dictionaryDescription;

}
