package cn.estsh.i3plus.pojo.platform.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description : 用户登录记录
 * @Reference   :
 * @Author      : wei.peng
 * @Date        : 2018-10-22 16:58:42.856
 * @Modify      :
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="SYS_LOG_USER_LOGIN")
@Api(value="用户登录记录",description = "用户登录记录")
public class SysLogUserLogin extends BaseBean {

    @Column(name="USER_ID")
    @ApiParam(value ="用户ID" , access ="用户ID")
    private Long userId;
 
    @Column(name="LOG_LOGIN_NAME")
    @ApiParam(value ="登录名称" , access ="登录名称")
    private String logLoginName;
 
    @Column(name="LOG_LOGIN_STATUS")
    @ApiParam(value ="登录状态（枚举：1.成功，2.失败，3锁定）" , example ="1")
    private Integer logLoginStatus;
 
    @Column(name="LOG_LOGIN_PLATFORM")
    @ApiParam(value ="登录平台ID（枚举）" , example ="1")
    private Integer logLoginPlatform;
 
    @Column(name="LOG_LOGIN_HOST")
    @ApiParam(value ="登录IP" , access ="登录IP")
    private String logLoginHost;
 
    @Column(name="LOG_LOGIN_DATE_TIME")
    @ApiParam(value ="登录时间" , access ="登录时间")
    private String logLoginDateTime;

}
